% GUI do programu demonstrujacego dzialanie 
% algorytmu genetycznego w zadaniu znajdowanie maximimum
% podanej funkcji
%
%
% Wartosci stale
npop = 10;
ngen = 10;
px = 0.8;
xtype = 1;
elite = 1;
ffunc=1;
len=[10,10];
pm = 1/(len(1)+len(2));

%
% Otwarcie okna glownego
%
 fig = findobj('Type','figure','Tag','GA Demo');
 if ~isempty(fig) 
     close(fig);
 end 
%
% GUI
%
 fig = figure('Units','Normalized',...
               'Position',[.1 .1 .4 .4], ...
               'Name','GA Demo',...
               'MenuBar','none',...
               'NumberTitle','off',...
               'Tag','GA Demo');
 set(fig,'DefaultUicontrolUnits','normal') 
 set(fig,'DefaultUicontrolFontName', 'Arial');
 set(fig,'DefaultUicontrolFontSize', 9);
 
 % Liczba zmiennych
 t = uicontrol('Style','text',...
               'Units','normal', ...
               'Position',[.05 .90 .6 .05],...
               'String',' Funkcja optymalizowana:');
 func = uicontrol('Style','popupmenu',...
                 'Units','normal', ...
                 'Position',[.70 .90 .25 .05],...
                 'String','Bohachevsky|Rosenbrock|Michalewicz|Easom|Schwefel');

 call = ['ffunc = get(func,''Value'');',...
         'ffuncs = get(func,''String'');',...
         'fprintf(''Wybrano funkcje %s.\n'',ffuncs(ffunc,:))'];
 set(func,'CallBack',call);
 
 
 % Dlugosc chromosomu
 t2= uicontrol('Style','text',...
               'Units','normal', ...
               'Position',[.05 .80 .6 .05],...
               'String',' Liczba bitów (genów) na zmienne: ');
 uicontrol('Style','text', 'Units','normal','Position',[.7 .80 .03 .05],'String','x:');             
 uh2(1) = uicontrol('Style','edit',...
                     'Units','normal', ...
                     'Position',[0.73 .80 .08 .05],...
                     'String',num2str(len(1)),...
                     'Callback','uh2(1)');
 call = ['str = get(uh2(1),''String'');', ...
          'len(1) = str2num(str);', ...
          'fprintf(''Liczba genów dla zmiennej 1: %d.\n'',len(1))'];
 set(uh2(1),'CallBack',call); 
 uicontrol('Style','text', 'Units','normal','Position',[.84 .80 .03 .05],'String','y:');               
 uh2(2) = uicontrol('Style','edit',...
                     'Units','normal', ...
                     'Position',[0.87 .80 .08 .05],...
                     'String',num2str(len(2)),...
                     'Callback','uh2(1)');
 call = ['str = get(uh2(2),''String'');', ...
          'len(2) = str2num(str);', ...
          'fprintf(''Liczba genów dla zmiennej 2: %d.\n'',len(2))'];
 set(uh2(2),'CallBack',call);  
  
  
% Zmienne wartoci dla AG 
% licznosc populacji
 t3= uicontrol('Style','text',...
                'Units','normal', ...
                'Position',[.05 .70 .6 .05],...
                'String',' Licznosc populacji:');
 popl = uicontrol('Style','edit',...
                  'Units','normal', ...
                  'Position',[.7 .70 .25 .05],...
                  'String',num2str(npop),...
                  'Callback','popl');
 call = ['str = get(popl,''String'');', ...
          'npop = str2num(str);', ...
          'fprintf(''Licznosc populacji %d.\n'',npop)'];
 set(popl,'CallBack',call);
 
% liczba egeneracji
 t4= uicontrol('Style','text',...
                'Units','normal', ...
                'Position',[.05 .60 .6 .05],...
                'String',' Liczba generacji:');
 ngen1 = uicontrol('Style','edit',...
                   'Units','normal', ...
                   'Position',[.7 .60 .25 .05],...  
                   'String',num2str(ngen),...
                   'Callback','ngenl');
 call = ['str = get(ngen1,''String'');', ...
         'ngen = str2num(str);', ...
         'fprintf(''Liczba generacji %d.\n'',ngen)'];
 set(ngen1,'CallBack',call)
 
%Prawdopodobienstwo mutacji 
 t5= uicontrol('Style','text',...
               'Units','normal', ...
               'Position',[.05 .50 .6 .05],...
               'String',' Prawdopodobienstwo mutacji:');
 pm1 = uicontrol('Style','edit',...
                 'Units','normal', ...
                 'Position',[.7 .50 .25 .05],...
                 'String',num2str(pm),...
                 'Callback','pml');
 call = ['str = get(pm1,''String'');', ...
         'pm = str2num(str);', ...
         'fprintf(''Prawdopodobienstwo mutacji:%1.3f.\n'',pm)'];
 set(pm1,'CallBack',call)
 
% prawdopodobienswo krzyzowania 
 t6= uicontrol('Style','text',...
               'Units','normal', ...
               'Position',[.05 .4 .6 .05],...
               'String',' Prawdopodobienstwo krzyzowania:');
 px1 = uicontrol('Style','edit',...
                 'Units','normal', ...
                 'Position',[.7 .4 .25 .05],...
                 'String',num2str(px),...
                 'Callback','pxl');
 call = ['str = get(px1,''String'');', ...
          'px = str2num(str);', ...
          'fprintf(''Prawdopodobienstwo krzyzowania: %1.3f\n'',px)'];
 set(px1,'CallBack',call)
% typ krzyzowania
 t7= uicontrol('Style','text',...
               'Units','normal', ...
               'Position',[.05 .3 .6 .05],...
               'String',' Typ krzyzowania:');
 xtypel = uicontrol('Style','Popupmenu',...
                    'Units','normal', ...
                    'Position',[.7 .3 .25 .05],...
                    'String','jednopunktowe|dwupunktowe|jednorodne');

 call = ['xtype = get(xtypel,''Value'');',...
         'xtypes = get(xtypel,''String'');',...
        'fprintf(''Typ krzyzowania %s.\n'',xtypes(xtype,:))'];
 set(xtypel,'CallBack',call);
 
% elitaryzm
 t8= uicontrol('Style','text',...
               'Units','normal', ...
               'Position',[.05 .2 .6 .05],...
               'String',' Elitaryzm');
 uelite = uicontrol('Style','checkbox',...
                    'Units','normal', ...
                    'Position',[.7 .2 0.05 0.05],...
                    'Value',elite);
 call = ['elite = get(uelite,''Value'');', ...
         'fprintf(''Elitaryzm: %d.\n'',elite)'];
  set(uelite,'CallBack',call)

%
% Przyciski
%
  button(1) = uicontrol('Style','pushbutton',...
                        'Position',[.05 .05 .25 .1],  ...
                        'call','gademo(len,npop,ngen,pm,px,xtype,elite,ffunc)',...
                        'string', 'Start');
  button(2) =  uicontrol('Style','pushbutton','Position',[.375 .05 .25 .1], ...
             'call',' graphics(ffunc,0,0,0) ','string','Wykres');     
  button(3) =  uicontrol('Style','pushbutton','Position',[.7 .05 .25 .1], ...
             'call','clear all ; close all ; ','string','Koniec');     